﻿Public Class FrmNewLendingBooks

#Region "Variables"
    Public LendingBook_ID_ As Int64 = -1
    Public CalledForm_ As FrmSelectLendingBooks = Nothing
    Public FormMode_ As Library_Shared.Enums.FormMode = Library_Shared.Enums.FormMode.None
    Private Book_ID_ As Int64 = -1
    Private Member_ID_ As Int64 = -1
#End Region

#Region "Controls And Forms Events"

    Private Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        Me.SaveData()
    End Sub

    Private Sub btnExit_Click(sender As Object, e As EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub

    Private Sub FrmNewMember_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Select Case Me.FormMode_
            Case Library_Shared.Enums.FormMode.حالت_افزودن
                Me.Text = "افزودن امانت کتاب"
                Dim TodayMiladi As Date = Date.Now
                txtLendDate.Text = Library_Shared.FarsiDate.Fa_Date(TodayMiladi)
                Dim dueDateMiladi As Date = TodayMiladi.AddDays(10) 'مدل دات نتی
                'Dim dueDateMiladi As Date = DateAdd(DateInterval.Day, 10, TodayMiladi) 'مدل ویژوال بیسیکی
                txtDueDate.Text = Library_Shared.FarsiDate.Fa_Date(dueDateMiladi)
            Case Library_Shared.Enums.FormMode.حالت_ویرایش
                Me.Text = "ویرایش امانت کتاب"
                Me.ShowRecordInfo()
            Case Library_Shared.Enums.FormMode.حالت_نمایش
                Me.Text = "نمایش امانت کتاب"
                Me.ShowRecordInfo()
                btnSave.Enabled = False
                txtMembershipCode.ReadOnly = True
                txtFirstName.ReadOnly = True
                txtLastName.ReadOnly = True
                txtRowDesc.ReadOnly = True
                txtLendDate.ReadOnly = True
                txtDueDate.ReadOnly = True
                txtReturnDate.ReadOnly = True
                btnSelectMembers.Enabled = False
                btnSelectBooks.Enabled = False
                btnClearBooks.Enabled = False
                btnClearMembers.Enabled = False
        End Select
    End Sub

    Private Sub btnSelectBooks_Click(sender As Object, e As EventArgs) Handles btnSelectBooks.Click
        Dim FrmNew_ As New FrmSelectBooks
        With FrmNew_
            .ShowDialog()
            If .IsSelected = True Then
                Me.Book_ID_ = .ReturnID
                Me.txtBookCode.Text = .ReturnCode
                Me.txtTitle.Text = .ReturnName
            End If
        End With
    End Sub

    Private Sub btnClearBooks_Click(sender As Object, e As EventArgs) Handles btnClearBooks.Click
        Me.Book_ID_ = -1
        Me.txtBookCode.Text = ""
        Me.txtTitle.Text = ""
    End Sub

    Private Sub btnSelectMembers_Click(sender As Object, e As EventArgs) Handles btnSelectMembers.Click
        Dim FrmNew_ As New FrmSelectMembers
        With FrmNew_
            .ShowDialog()
            If .IsSelected = True Then
                Me.Member_ID_ = .ReturnID
                Me.txtMembershipCode.Text = .ReturnCode
                Me.txtFirstName.Text = .ReturnFirstName
                Me.txtLastName.Text = .ReturnLastName
            End If
        End With
    End Sub

    Private Sub btnClearMembers_Click(sender As Object, e As EventArgs) Handles btnClearMembers.Click
        Me.Member_ID_ = -1
        Me.txtMembershipCode.Text = ""
        Me.txtFirstName.Text = ""
        Me.txtLastName.Text = ""
    End Sub

#End Region

#Region "My Rutins"

    Private Sub SaveData()
        If Validation() = False Then Exit Sub
        Select Case Me.FormMode_
            Case Library_Shared.Enums.FormMode.حالت_افزودن
                If Me.Insert_ = True Then
                    MsgBox("رکورد با موفقیت اضافه شد", MsgBoxStyle.Information, "پیغام")
                    Me.ClearForm()
                    Me.CalledForm_.FillGrid()
                End If
            Case Library_Shared.Enums.FormMode.حالت_ویرایش
                If Me.Update_ = True Then
                    MsgBox("رکورد با موفقیت ویرایش شد", MsgBoxStyle.Information, "پیغام")
                    Me.Close()
                    Me.CalledForm_.FillGrid()
                End If
        End Select
    End Sub

    Private Function Insert_() As Boolean
        Dim obj_Members As New Library_Database.Library.LendingBooks
        Dim IsComplete As Boolean = obj_Members.INSERT(Me.Book_ID_, Me.Member_ID_, txtLendDate.Text, txtDueDate.Text, txtReturnDate.Text, txtRowDesc.Text)
        Return IsComplete
    End Function

    Private Function Update_() As Boolean
        Dim obj_Members As New Library_Database.Library.LendingBooks
        Dim IsComplete As Boolean = obj_Members.UPDATE(Me.LendingBook_ID_, Me.Book_ID_, Me.Member_ID_, txtLendDate.Text, txtDueDate.Text, txtReturnDate.Text, txtRowDesc.Text)
        Return IsComplete
    End Function

    Private Sub ShowRecordInfo()
        Dim obj_Members As New Library_Database.Library.LendingBooks
        Dim dt As DataTable = obj_Members.SELECT_ByID(Me.LendingBook_ID_)
        If dt.Rows.Count > 0 Then
            Me.Book_ID_ = CLng(dt.Rows(0).Item("Book_ID"))
            Me.Member_ID_ = CLng(dt.Rows(0).Item("Member_ID"))
            txtLendDate.Text = dt.Rows(0).Item("LendDate").ToString
            txtDueDate.Text = dt.Rows(0).Item("DueDate").ToString
            txtReturnDate.Text = dt.Rows(0).Item("ReturnDate").ToString
            txtBookCode.Text = dt.Rows(0).Item("BookCode").ToString
            txtTitle.Text = dt.Rows(0).Item("Title").ToString
            txtMembershipCode.Text = dt.Rows(0).Item("MembershipCode").ToString
            txtFirstName.Text = dt.Rows(0).Item("FirstName").ToString
            txtLastName.Text = dt.Rows(0).Item("LastName").ToString
            txtRowDesc.Text = dt.Rows(0).Item("RowDesc").ToString
        End If
    End Sub

    Private Function Validation() As Boolean
        '---------------------
        'Dim obj_Members As New Library_Database.Library.LendingBooks
        '---------------------
        'PreValidation
        txtLendDate.Text = txtLendDate.Text.Trim
        txtDueDate.Text = txtDueDate.Text.Trim
        txtReturnDate.Text = txtReturnDate.Text.Trim
        '---------------------
        If Me.Member_ID_ = -1 Then
            MsgBox("عضوی انتخاب نشده است", MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
            btnSelectMembers.Focus()
            Return False
            Exit Function
        End If
        '---------------------
        If Me.Book_ID_ = -1 Then
            MsgBox("کتابی انتخاب نشده است", MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
            btnSelectBooks.Focus()
            Return False
            Exit Function
        End If
        '---------------------
        If Library_Shared.FarsiDate.Test_Date(txtLendDate.Text) <> "" Then
            MsgBox(Library_Shared.FarsiDate.Test_Date(txtLendDate.Text), MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
            txtLendDate.Focus()
            Return False
            Exit Function
        End If
        '---------------------
        If Library_Shared.FarsiDate.Test_Date(txtDueDate.Text) <> "" Then
            MsgBox(Library_Shared.FarsiDate.Test_Date(txtDueDate.Text), MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
            txtDueDate.Focus()
            Return False
            Exit Function
        End If
        '---------------------
        If txtReturnDate.Text.Length > 0 Then
            If Library_Shared.FarsiDate.Test_Date(txtReturnDate.Text) <> "" Then
                MsgBox(Library_Shared.FarsiDate.Test_Date(txtReturnDate.Text), MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
                txtReturnDate.Focus()
                Return False
                Exit Function
            End If
        End If
        '---------------------
        Return True
    End Function

    Private Sub ClearForm()
        Me.Member_ID_ = -1
        Me.Book_ID_ = -1
        txtFirstName.Text = ""
        txtLastName.Text = ""
        txtMembershipCode.Text = ""
        txtBookCode.Text = ""
        txtTitle.Text = ""
        txtLendDate.Text = ""
        txtDueDate.Text = ""
        txtReturnDate.Text = ""
        txtRowDesc.Text = ""
    End Sub

#End Region

End Class