﻿Public Class FrmNewMember

#Region "Variables"
    Public Member_ID_ As Int64 = -1
    Public CalledForm_ As FrmSelectMembers = Nothing
    Public FormMode_ As Library_Shared.Enums.FormMode = Library_Shared.Enums.FormMode.None
#End Region

#Region "Controls And Forms Events"

    Private Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        Me.SaveData()
    End Sub

    Private Sub btnExit_Click(sender As Object, e As EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub

    Private Sub FrmNewMember_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Select Case Me.FormMode_
            Case Library_Shared.Enums.FormMode.حالت_افزودن
                Me.Text = "افزودن عضو جدید"
            Case Library_Shared.Enums.FormMode.حالت_ویرایش
                Me.Text = "ویرایش عضو"
                Me.ShowRecordInfo()
            Case Library_Shared.Enums.FormMode.حالت_نمایش
                Me.Text = "نمایش عضو"
                Me.ShowRecordInfo()
                btnSave.Enabled = False
                txtMembershipCode.ReadOnly = True
                txtFirstName.ReadOnly = True
                txtLastName.ReadOnly = True
                txtMobileNumber.ReadOnly = True
                txtNationalCode.ReadOnly = True
                txtPhoneNumbers.ReadOnly = True
                txtRowDesc.ReadOnly = True
        End Select
    End Sub

#End Region

#Region "My Rutins"

    Private Sub SaveData()
        If Validation() = False Then Exit Sub
        Select Case Me.FormMode_
            Case Library_Shared.Enums.FormMode.حالت_افزودن
                If Me.Insert_ = True Then
                    MsgBox("رکورد با موفقیت اضافه شد", MsgBoxStyle.Information, "پیغام")
                    Me.ClearForm()
                    Me.CalledForm_.FillGrid()
                End If
            Case Library_Shared.Enums.FormMode.حالت_ویرایش
                If Me.Update_ = True Then
                    MsgBox("رکورد با موفقیت ویرایش شد", MsgBoxStyle.Information, "پیغام")
                    Me.Close()
                    Me.CalledForm_.FillGrid()
                End If
        End Select
    End Sub

    Private Function Insert_() As Boolean
        Dim obj_Members As New Library_Database.Library.Members
        Dim IsComplete As Boolean = obj_Members.INSERT(txtMembershipCode.Text, txtFirstName.Text, txtLastName.Text, txtNationalCode.Text, txtPhoneNumbers.Text, txtMobileNumber.Text, txtRowDesc.Text)
        Return IsComplete
    End Function

    Private Function Update_() As Boolean
        Dim obj_Members As New Library_Database.Library.Members
        Dim IsComplete As Boolean = obj_Members.UPDATE(Me.Member_ID_, txtMembershipCode.Text, txtFirstName.Text, txtLastName.Text, txtNationalCode.Text, txtPhoneNumbers.Text, txtMobileNumber.Text, txtRowDesc.Text)
        Return IsComplete
    End Function

    Private Sub ShowRecordInfo()
        Dim obj_Members As New Library_Database.Library.Members
        Dim dt As DataTable = obj_Members.SELECT_ByID(Me.Member_ID_)
        If dt.Rows.Count > 0 Then
            txtFirstName.Text = dt.Rows(0).Item("FirstName").ToString
            txtLastName.Text = dt.Rows(0).Item("LastName").ToString
            txtMembershipCode.Text = dt.Rows(0).Item("MembershipCode").ToString
            txtMobileNumber.Text = dt.Rows(0).Item("MobileNumber").ToString
            txtNationalCode.Text = dt.Rows(0).Item("NationalCode").ToString
            txtPhoneNumbers.Text = dt.Rows(0).Item("PhoneNumbers").ToString
            txtRowDesc.Text = dt.Rows(0).Item("RowDesc").ToString
        End If
    End Sub

    Private Function Validation() As Boolean
        '---------------------
        Dim obj_Members As New Library_Database.Library.Members
        '---------------------
        'PreValidation
        txtMembershipCode.Text = txtMembershipCode.Text.Trim
        txtFirstName.Text = txtFirstName.Text.Trim
        txtLastName.Text = txtLastName.Text.Trim
        txtNationalCode.Text = txtNationalCode.Text.Trim
        '---------------------
        If txtMembershipCode.Text.Length = 0 Then
            MsgBox("کد عضویت را وارد کنید", MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
            txtMembershipCode.Focus()
            Return False
            Exit Function
        End If
        '---------------------
        If IsNumeric(txtMembershipCode.Text) = False Then
            MsgBox("کد عضویت صحیح نمی باشد", MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
            txtMembershipCode.Focus()
            Return False
            Exit Function
        End If
        '---------------------
        If CLng(txtMembershipCode.Text) <= 0 Then
            MsgBox("کد عضویت نمی تواند صفر یا عددی منفی باشد", MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
            txtMembershipCode.Focus()
            Return False
            Exit Function
        End If
        '---------------------
        If txtFirstName.Text.Length = 0 Then
            MsgBox("نام را وارد کنید", MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
            txtFirstName.Focus()
            Return False
            Exit Function
        End If
        '---------------------
        If txtLastName.Text.Length = 0 Then
            MsgBox("نام خانوادگی را وارد کنید", MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
            txtLastName.Focus()
            Return False
            Exit Function
        End If
        '---------------------
        If txtNationalCode.Text.Length > 0 Then
            '--------------
            If txtNationalCode.Text.Length <> 10 Then
                MsgBox("کد ملی صحیح نمی باشد", MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
                txtNationalCode.Focus()
                Return False
                Exit Function
            End If
            '--------------
            If IsNumeric(txtNationalCode.Text) = False Then
                MsgBox("کد ملی صحیح نمی باشد", MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
                txtNationalCode.Focus()
                Return False
                Exit Function
            End If
            '--------------
        End If
        '---------------------
        If obj_Members.IsExist_MembershipCode(txtMembershipCode.Text, Me.Member_ID_) = True Then
            MsgBox("کد عضویت تکراری می باشد", MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
            txtMembershipCode.Focus()
            Return False
            Exit Function
        End If
        '---------------------
        Return True
    End Function

    Private Sub ClearForm()
        txtFirstName.Text = ""
        txtLastName.Text = ""
        txtMembershipCode.Text = ""
        txtMobileNumber.Text = ""
        txtNationalCode.Text = ""
        txtPhoneNumbers.Text = ""
        txtRowDesc.Text = ""
    End Sub

#End Region




End Class