﻿Public Class FrmSelectBooks

#Region "Variables"

#End Region

#Region "Properties"

    Private IsSelectedValue As Boolean = False
    Public Property IsSelected() As Boolean
        Get
            Return IsSelectedValue
        End Get
        Set(ByVal value As Boolean)
            IsSelectedValue = value
        End Set
    End Property

    Private ReturnIDValue As Int64 = -1
    Public Property ReturnID() As Int64
        Get
            Return ReturnIDValue
        End Get
        Set(ByVal value As Int64)
            ReturnIDValue = value
        End Set
    End Property

    Private ReturnCodeValue As String = ""
    Public Property ReturnCode() As String
        Get
            Return ReturnCodeValue
        End Get
        Set(ByVal value As String)
            ReturnCodeValue = value
        End Set
    End Property

    Private ReturnNameValue As String = ""
    Public Property ReturnName() As String
        Get
            Return ReturnNameValue
        End Get
        Set(ByVal value As String)
            ReturnNameValue = value
        End Set
    End Property

#End Region

#Region "Controls And Forms Events"

    Private Sub btnSearch_Click(sender As Object, e As EventArgs) Handles btnSearch.Click
        FillGrid()
    End Sub

    Private Sub FrmSelectMembers_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        cboSearch.SelectedIndex = 0
        cboSortField.SelectedIndex = 0
        cboSortType.SelectedIndex = 0
    End Sub

    Private Sub btnAdd_Click(sender As Object, e As EventArgs) Handles btnAdd.Click
        Dim Frm_ As New FrmNewBooks
        Frm_.CalledForm_ = Me
        Frm_.FormMode_ = Library_Shared.Enums.FormMode.حالت_افزودن
        Frm_.Show()
        Frm_.Focus()
    End Sub

    Private Sub btnEdit_Click(sender As Object, e As EventArgs) Handles btnEdit.Click
        If DataGridView1.Rows.Count = 0 Then
            MsgBox("رکوردی جهت ویرایش انتخاب نشده است", MsgBoxStyle.Critical, "خطا")
            Exit Sub
        End If
        Dim Frm_ As New FrmNewBooks
        Frm_.CalledForm_ = Me
        Frm_.FormMode_ = Library_Shared.Enums.FormMode.حالت_ویرایش
        Frm_.Book_ID_ = CLng(DataGridView1.CurrentRow.Cells.Item("RowID").Value)
        Frm_.Show()
        Frm_.Focus()
    End Sub

    Private Sub btnView_Click(sender As Object, e As EventArgs) Handles btnView.Click
        If DataGridView1.Rows.Count = 0 Then
            MsgBox("رکوردی جهت نمایش انتخاب نشده است", MsgBoxStyle.Critical, "خطا")
            Exit Sub
        End If
        Dim Frm_ As New FrmNewBooks
        Frm_.CalledForm_ = Me
        Frm_.FormMode_ = Library_Shared.Enums.FormMode.حالت_نمایش
        Frm_.Book_ID_ = CLng(DataGridView1.CurrentRow.Cells.Item("RowID").Value)
        Frm_.Show()
        Frm_.Focus()
    End Sub

    Private Sub btnDelete_Click(sender As Object, e As EventArgs) Handles btnDelete.Click
        If DataGridView1.Rows.Count = 0 Then
            MsgBox("رکوردی جهت حذف انتخاب نشده است", MsgBoxStyle.Critical, "خطا")
            Exit Sub
        End If
        If MsgBox("آیا از حذف رکورد انتخاب شده مطمئن هستید", MsgBoxStyle.Question + MsgBoxStyle.YesNo, "تایید حذف") = MsgBoxResult.No Then Exit Sub

        Dim obj_Books As New Library_Database.Library.Books
        Dim IsComplete As Boolean = obj_Books.DELETE(CLng(DataGridView1.CurrentRow.Cells.Item("RowID").Value))

        If IsComplete = True Then
            MsgBox("رکورد با موفقیت حذف شد", MsgBoxStyle.Information, "پیغام")
            Me.FillGrid()
        End If
    End Sub

    Private Sub btnSelect_Click(sender As Object, e As EventArgs) Handles btnSelect.Click
        If DataGridView1.Rows.Count = 0 Then
            MsgBox("رکوردی انتخاب نشده است", MsgBoxStyle.Critical, "خطا")
            Exit Sub
        End If
        Me.ReturnIDValue = CLng(DataGridView1.CurrentRow.Cells.Item("RowID").Value)
        Me.ReturnCodeValue = DataGridView1.CurrentRow.Cells.Item("BookCode").Value.ToString
        Me.ReturnNameValue = DataGridView1.CurrentRow.Cells.Item("Title").Value.ToString
        Me.IsSelected = True
        Me.Close()
    End Sub

    Private Sub DataGridView1_MouseDoubleClick(sender As Object, e As MouseEventArgs) Handles DataGridView1.MouseDoubleClick
        btnSelect.PerformClick()
    End Sub

#End Region

#Region "My Rutins"

    Public Sub FillGrid()
        Dim obj_Books As New Library_Database.Library.Books
        Dim dt As DataTable = obj_Books.SELECT_ALL(cboSearch.SelectedIndex, txtSearch.Text.Trim, cboSortField.SelectedIndex, cboSortType.SelectedIndex)
        DataGridView1.DataSource = dt
    End Sub

#End Region





 



End Class